.\"Copyright 1991 by Chris Lewis 2.1 91/03/24
.TH ASC2PS %%MANEXT%% "Psroff %%T2VERSION%%"
.SH NAME
asc2ps \- ASCII to Postscript converter
.SH SYNOPSIS
.B asc2ps
.B "[\-l]"
.B "[\-L]"
.B "[\-p]"
.B "[\-P]"
.B "[\-i]"
.BI "[\-s" n "]"
files
.SH DESCRIPTION
.B Asc2ps
Converts ASCII files into Postscript.
If no files are specified, stdin is used.
It is a simple converter, primarily intended to support ``line printer''
applications - such as listing programs or, one of its strengths, the output
of nroff.
.PP
.B Asc2ps
recognizes character<backspace>character sequences specially.
If the two characters are the same, this results in selecting the bold
font for the character.
If one of the characters is an underline, the output is underlined, unless
\-i is specified, in which case the character is italicized.
Ideal for nroff output (bold versus italic print).
If neither of the above hold, all but the last character in the backspace
sequence is ignored.
.PP
By default, it treats a 8\(12\(mu11 inch page as 66 lines of 12 point Courier.
The \-P option is for 8\(12\(mu14 inch.
The \-l option requests 66 line high printing, landscape on 8\(12\(mu11,
and \-L requests landscape on 8\(12\(mu14.
By default, the landscape point size is 7.2 - which gives approximately
180 character wide printing in landscape on 8\(12\(mu11 inch paper - ideal
for side-by-side printing via ``pr -2'' or
.BR sdiff .
.PP
You can select the pointsize by using
the \-s option.
This doesn't affect line spacing.
.PP
.B Asc2ps
is encorporated into the
.B psxlate
program.
When
.B psxlate
implicitly invokes
.BR asc2ps ,
the output is 66 lines per page, 8\(12\(mu11 inches.
.SH BUGS
No provision for page sizes other than 8\(12\(mu11 and 8\(12\(mu14 inches.
Should support European paper sizes.
Maybe next go-round.
.SH "SEE ALSO"
psxlate(%%MANEXT%%)
.SH AUTHOR
Written by Chris Lewis
