#! %%PERL%%
eval "exec  %%PERL%% -S $0 $*"
	if $running_under_some_shell;

#	Copyright 1985, 1986, 1987, 1988, 1989, 1990, 1991 Chris Lewis
#		All Rights Reserved
#
#    See the LICENSE file for a full description of the restrictions
#    under which this software is provided.
#
#	This does a very simpleminded conversion of ditroff-only-isms
#	(such as graphics) into something handleable by CAT troff.
#	1.9 91/11/22
$cc{'em'}=1; $cc{'ru'}=1; $cc{'14'}=1; $cc{'12'}=1; $cc{'hy'}=1;
$cc{'34'}=1; $cc{'fi'}=1; $cc{'fl'}=1; $cc{'ff'}=1; $cc{'ct'}=1;
$cc{'Fl'}=1; $cc{'Fi'}=1; $cc{'de'}=1; $cc{'dg'}=1; $cc{'rg'}=1;
$cc{'bu'}=1; $cc{'fm'}=1; $cc{'co'}=1; $cc{'sq'}=1; $cc{'*q'}=1;
$cc{'*h'}=1; $cc{'*n'}=1; $cc{'*m'}=1; $cc{'*l'}=1; $cc{'*i'}=1;
$cc{'*z'}=1; $cc{'*s'}=1; $cc{'*d'}=1; $cc{'*b'}=1; $cc{'*c'}=1;
$cc{'*y'}=1; $cc{'*f'}=1; $cc{'*u'}=1; $cc{'*k'}=1; $cc{'*p'}=1;
$cc{'da'}=1; $cc{'*a'}=1; $cc{'or'}=1; $cc{'*x'}=1; $cc{'*e'}=1;
$cc{'eq'}=1; $cc{'*o'}=1; $cc{'<-'}=1; $cc{'*r'}=1; $cc{'ua'}=1;
$cc{'*t'}=1; $cc{'ul'}=1; $cc{'*Q'}=1; $cc{'bs'}=1; $cc{'if'}=1;
$cc{'*g'}=1; $cc{'ip'}=1; $cc{'pt'}=1; $cc{'rh'}=1; $cc{'*w'}=1;
$cc{'gr'}=1; $cc{'*F'}=1; $cc{'*H'}=1; $cc{'*W'}=1; $cc{'cu'}=1;
$cc{'rn'}=1; $cc{'ts'}=1; $cc{'*L'}=1; $cc{'mi'}=1; $cc{'*G'}=1;
$cc{'is'}=1; $cc{'*P'}=1; $cc{'sb'}=1; $cc{'sp'}=1; $cc{'ap'}=1;
$cc{'pd'}=1; $cc{'*D'}=1; $cc{'sr'}=1; $cc{'*S'}=1; $cc{'~='}=1;
$cc{'*C'}=1; $cc{'sl'}=1; $cc{'ca'}=1; $cc{'*U'}=1; $cc{'no'}=1;
$cc{'rc'}=1; $cc{'lt'}=1; $cc{'bv'}=1; $cc{'lk'}=1; $cc{'lb'}=1;
$cc{'rt'}=1; $cc{'rk'}=1; $cc{'rb'}=1; $cc{'rf'}=1; $cc{'lf'}=1;
$cc{'lc'}=1; $cc{'mu'}=1; $cc{'di'}=1; $cc{'+-'}=1; $cc{'<='}=1;
$cc{'>='}=1; $cc{'=='}=1; $cc{'!='}=1; $cc{'aa'}=1; $cc{'ga'}=1;
$cc{'lh'}=1; $cc{'mo'}=1; $cc{'es'}=1; $cc{'dd'}=1; $cc{'br'}=1;
$cc{'**'}=1; $cc{'ib'}=1; $cc{'ci'}=1; $cc{'pl'}=1; $cc{'->'}=1;
$cc{'sc'}=1;

@regnames = split(//,
    "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
$regpref = "@";
$inpic = 0;
print(".de lf\n");
print(".mk\n");
print("..\n");

while($line = <STDIN>) {
    chop($line);
    $index = 0;
    if ($line =~ /^\.PS/) {
	$inpic = 1;
	print "$line\n";
	next;
    }
    if ($line =~ /^\.PE/) {
	$inpic = 0;
	print "$line\n";
	next;
    }
    if ($inpic && ($line eq '.sp -1')) {
	printf(".rt\n");
	next;
    }
    if ($line =~ /\\D'/) {
	$line = do process($line);
    }
    if ($line =~ /\\X'/) {
	$line = do Xprocess($line);
    }
    $line = do findspecials($line);
    if ($line =~ /^\\!(.*)/) {
	$line = ".sR \"$1\"";
    }
    print "$line\n";
    while($index) {
	print ".rr " . $regpref . $regnames[--$index] . "\n";
    }
}

sub findspecials {
    local($line, $newline, $pre, $opcode, $arglist) = ($_[0]);
#    printf("in process: $line\n");
    $predefs = '';
    while($line =~ /\\\((..)/) {
	($pre, $line, $char) = ($`, $', $1);
#	print("pre: $pre\nline: $line\nopcode: $opcode\narglist: $arglist\n");
	$newline .= $pre;
	if ($cc{$char}) {
	    $newline .= "\\($char";
	} else {
	    $newline .= "\\ka\\o'\\(bs\\(bs'C$char\\(bs\\h'|\\nau+1n'";
	}
    }
    $newline .= $line;
    return("$predefs$newline");
}

#	Convert drawing commands
sub process {
    local($line, $newline, $pre, $opcode, $arglist) = ($_[0]);
#    printf("in process: $line\n");
    $predefs = '';
    while($line =~ /\\D'\s*(.)\s*([^']+)'/) {
	($pre, $line, $opcode, $arglist) = ($`, $', $1, $2);
#	print("pre: $pre\nline: $line\nopcode: $opcode\narglist: $arglist\n");
	$newline .= $pre;
	$newargs = '';
	$newy = '';
	$newx = '';
	@args = split(/[ \t]+/, $arglist);
	for ($i = 0; $i <= $#args; $i++) {
	    $arg = $args[$i];
	    if ($arg =~ '-') {
		$arg = "0$arg";
	    }
	    $num = $regpref . $regnames[$index];
	    $predefs .= ".nr $num $arg\n";
	    $newargs .= "\\(ts\\n($num";
	    if ($opcode eq '~') {
		if ($i % 2) {
		    $newy .= "+\\n($num";
		} else {
		    $newx .= "+\\n($num";
		}
	    }
	    $index++;
	}
	$newline .= "\\ka\\o'\\(bs\\(bs'D$opcode$newargs\\(bs\\h'|\\nau";
	# Reposition...
	if ($opcode eq 'l') {
	    $newline .= sprintf("+\\n(%s%su'\\v'\\n(%s%su'",
		$regpref, $regnames[$index - 2], $regpref, $regnames[$index - 1]);
	} elsif ($opcode eq 'c' || $opcode eq 'C') {
	    $newline .= sprintf("+\\n(%s%su'", $regpref, $regnames[$index - 1]);
	} elsif ($opcode eq 'e' || $opcode eq 'E') {
	    $newline .= sprintf("+\\n(%s%su'", $regpref, $regnames[$index - 2]);
	} elsif ($opcode eq '~') {
	    # drop leading + sign
	    $newy = substr($newy, 1, 9999);
	    $newline .= "$newx'\\v'$newy'";
	} else {
	    $newline .= "'";
	}
	if ($line) {
	    $newline .= "\\\n";
	}
    }
    $newline .= $line;
    return("$predefs$newline");
}

#	Convert \X directives
sub Xprocess {
    local($line, $newline, $pre, $opcode, $arglist) = ($_[0]);
#    printf("in process: $line\n");
    $predefs = '';
    while($line =~ /\\X'\s*(.)\s*([^']+)'/) {
	($pre, $line, $opcode, $arglist) = ($`, $', $1, $2);
#	print("pre: $pre\nline: $line\nopcode: $opcode\narglist: $arglist\n");
	$newline .= $pre;
	$newargs = '';
	$newy = '';
	$newx = '';

	if ($arglist =~ /\\/) {		# has arithmetic in it
	    if ($arglist =~ '-') {
		$arglist = "0$arglist";
	    }
	    $num = $regpref . $regnames[$index];
	    $predefs .= ".nr $num $arglist\n";
	    $newargs = "\\(ts\\n($num";
	    $index++;
	} else {
	    $newargs = "$arglist";
	}
	$newline .= "\\ka\\o'\\(bs\\(bs'$opcode$newargs\\(bs\\h'|\\nau'";
    }
    $newline .= $line;
    return("$predefs$newline");
}
