%%STARTSHELL%%
#	Copyright 1985, 1986, 1987, 1988, 1989, 1990, 1991 Chris Lewis
#		All Rights Reserved
#
#    See the LICENSE file for a full description of the restrictions
#    under which this software is provided.
#
#    Function: laserjet to postscript converter
#2.2 91/02/20
if [ $# != 0 ]
then
    dontdelete=1
fi
if [ -f utils/hpinterp ]
then
    hpinterp=`pwd`/utils/hpinterp
else
    hpinterp=%%LIBDIR%%/hpinterp
fi

if [ -f utils/pk2ps ]
then
    pk2ps=`pwd`/utils/pk2ps
else
    pk2ps=%%LIBDIR%%/pk2ps
fi

td=/tmp/$$
(
    mkdir $td
    cd $td
    mkdir FONTS
    $hpinterp -p > postscript
    rm FONTS/*.desc
    $pk2ps -f FONTS/* > fonts
    cat fonts postscript
    echo "\004"
)
if [ -z "$dontdelete" ]
then
    rm -fr $td
fi
